﻿@model ASP.NET_MVC5_WebShopExample.Models.SpecificationType
@using ASP.NET_MVC5_WebShopExample.Models
@using ASP.NET_MVC5_WebShopExample.Constants

@{
    ViewBag.Title = "Edit";
}

<h2>Edit</h2>


@using (Html.BeginForm())
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">
        <h4>SpecificationType</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        @Html.HiddenFor(model => model.SpecificationTypeId)

        <div class="form-group">
            @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Unit, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Unit, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Unit, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Filter, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownListFor(model => model.Filter, ViewBag.SpecificationFilters as SelectList, new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.Filter, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.Label("selectedCategoryIds", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @if (ViewBag.UsedCategories == null)
                {
                    @Html.ListBox("selectedCategoryIds", ViewBag.Categories as MultiSelectList, new { @class = "form -control", autocomplete = "off" });
                }
                else
                {
                    @Html.ListBox("selectedCategoryIdsDisabled", ViewBag.Categories as MultiSelectList, new { @class = "form -control", autocomplete = "off", disabled = "disabled" });
                    foreach (var selectedCategoryId in ViewBag.selectedCategoryIds as IEnumerable<int>)
                    {
                        <input type="hidden" name="selectedCategoryIds" value="@selectedCategoryId" /> @* List box with disabled attribute do not sending to server with form *@
                    }
                }
                @Html.ValidationMessage("selectedCategoryIds", "", new { @class = "text-danger" })
            </div>
        </div>

        @if (ViewBag.UsedCategories != null)
        {
            @Html.Hidden("isContinueSaving", true);
            <p class="text-danger">
                Specification type can`t continue used by following specifications of products, 
                by reason of disabled following categories for specification type.
                If you save editied specification type, the following specification will be removed, or you can back to list of specification types
            </p>
            <ul>
                @foreach (var usedCategory in ViewBag.UsedCategories as ICollection<Category>)
                {
                    <li>
                        Category: @Html.ActionLink(
                          $"ID:{usedCategory.CategoryId} - {usedCategory.Name}",
                          "Details",
                          "Categories",
                          new { id = usedCategory.CategoryId },
                          null)
                        <ul>
                            @foreach (var usedProduct in usedCategory.Products)
                            {
                                <li>
                                    Product: @Html.ActionLink(
                                       $"ID:{usedProduct.ProductId} - {usedProduct.Name}",
                                       "Details",
                                       "Products",
                                       new { id = usedProduct.ProductId },
                                       null)
                                    <ul>
                                        @foreach (var usedSpecification in usedProduct.Specifications)
                                        {
                                            if(usedSpecification.SpecificationTypeId == Model.SpecificationTypeId)
                                            {
                                                <li>
                                                    Specification: @Html.RouteLink(
                                                         $"ID: {usedSpecification.SpecificationId} - {usedSpecification.Value} {usedSpecification.SpecificationType.Unit}",
                                                         RouteNames.Specifications,
                                                         new
                                                         {
                                                             productId = usedProduct.ProductId,
                                                             action = "Edit",
                                                             id = usedSpecification.SpecificationId
                                                         })
                                                    <span class="text-danger">will be removed</span>
                                                </li>
                                            }
                                        }
                                    </ul>
                                </li>
                            }
                        </ul>
                    </li>

                }
            </ul>
        }

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                @if (ViewBag.UsedCategories != null)
                {
                    <input type="submit" value="Continue saving" class="btn btn-danger" />
                    @Html.ActionLink("Cancel", "Edit", new { id = Model.SpecificationTypeId }, new { @class = "btn btn-default" })
                }
                else
                {
                    <input type="submit" value="Save" class="btn btn-default" />
                }
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}
